using System;
using System.Drawing;
using System.Windows.Forms;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Chart;

namespace CustomZooming
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private Point downPoint = Point.Empty;
        private Point upPoint = Point.Empty;

        private void chartControl1_ChartRegionMouseDown(object sender, ChartRegionMouseEventArgs e)
        {
            this.downPoint = e.Point;
        }

        private void chartControl1_ChartRegionMouseMove(object sender, ChartRegionMouseEventArgs e)
        {
            if (MouseButtons != MouseButtons.Left)
            {
                return;
            }

            ChartControl chart = sender as ChartControl;
            if (chart == null)
            {
                return;
            }


            if (this.downPoint != Point.Empty && e.Point != Point.Empty)
            {
                Rectangle rect = new Rectangle();

                rect.X = Math.Min(this.downPoint.X, e.Point.X);
                rect.Width = Math.Abs(e.Point.X - this.downPoint.X);
                rect.Y = chart.ChartArea.RenderBounds.Y;
                rect.Height = chart.ChartArea.RenderBounds.Height;

                Rectangle tempRect = rect;

                // Adjust for bounds
                rect.X = Math.Max(tempRect.Left, chart.ChartArea.RenderBounds.Left);
                rect.Width = Math.Min(tempRect.Right, chart.ChartArea.RenderBounds.Right) - rect.X;

                BrushInfo br = new BrushInfo(125, new BrushInfo(SystemColors.Highlight));
                BrushPaint.FillRectangle(chart.GetGraphics(), rect, br);
            }
        }

        private void chartControl1_ChartRegionMouseUp(object sender, ChartRegionMouseEventArgs e)
        {
            this.upPoint = e.Point;

            this.textBox1.Text = String.Format("down: {0} up: {1}", this.downPoint, this.upPoint);
        }
    }
}